# StatementItemsInner

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**Id** | Pointer to **string** | Унікальний id транзакції | [optional] 
**Time** | Pointer to **float32** | Час транзакції в секундах в форматі Unix time | [optional] 
**Description** | Pointer to **string** | Опис транзакцій | [optional] 
**Mcc** | Pointer to **float32** | Код типу транзакції (Merchant Category Code), відповідно ISO 18245 | [optional] 
**OriginalMcc** | Pointer to **float32** | Оригінальний код типу транзакції (Merchant Category Code), відповідно ISO 18245 | [optional] 
**Hold** | Pointer to **bool** | Статус блокування суми (детальніше у [wiki](https://en.wikipedia.org/wiki/Authorization_hold)) | [optional] 
**Amount** | Pointer to **float32** | Сума у валюті рахунку в мінімальних одиницях валюти (копійках, центах) | [optional] 
**OperationAmount** | Pointer to **float32** | Сума у валюті транзакції в мінімальних одиницях валюти (копійках, центах) | [optional] 
**CurrencyCode** | Pointer to **float32** | Код валюти рахунку відповідно ISO 4217 | [optional] 
**CommissionRate** | Pointer to **float32** | Розмір комісії в мінімальних одиницях валюти (копійках, центах) | [optional] 
**CashbackAmount** | Pointer to **float32** | Розмір кешбеку в мінімальних одиницях валюти (копійках, центах) | [optional] 
**Balance** | Pointer to **float32** | Баланс рахунку в мінімальних одиницях валюти (копійках, центах) | [optional] 
**Comment** | Pointer to **string** | Коментар до переказу, уведений користувачем. Якщо не вказаний, поле буде відсутнім | [optional] 
**ReceiptId** | Pointer to **string** | Номер квитанції для check.gov.ua. Поле може бути відсутнім | [optional] 
**InvoiceId** | Pointer to **string** | Номер квитанції ФОПа, приходить у випадку якщо це операція із зарахуванням коштів | [optional] 
**CounterEdrpou** | Pointer to **string** | ЄДРПОУ контрагента, присутній лише для елементів виписки рахунків ФОП | [optional] 
**CounterIban** | Pointer to **string** | IBAN контрагента, присутній лише для елементів виписки рахунків ФОП | [optional] 
**CounterName** | Pointer to **string** | Найменування контрагента | [optional] 

## Methods

### NewStatementItemsInner

`func NewStatementItemsInner() *StatementItemsInner`

NewStatementItemsInner instantiates a new StatementItemsInner object
This constructor will assign default values to properties that have it defined,
and makes sure properties required by API are set, but the set of arguments
will change when the set of required properties is changed

### NewStatementItemsInnerWithDefaults

`func NewStatementItemsInnerWithDefaults() *StatementItemsInner`

NewStatementItemsInnerWithDefaults instantiates a new StatementItemsInner object
This constructor will only assign default values to properties that have it defined,
but it doesn't guarantee that properties required by API are set

### GetId

`func (o *StatementItemsInner) GetId() string`

GetId returns the Id field if non-nil, zero value otherwise.

### GetIdOk

`func (o *StatementItemsInner) GetIdOk() (*string, bool)`

GetIdOk returns a tuple with the Id field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetId

`func (o *StatementItemsInner) SetId(v string)`

SetId sets Id field to given value.

### HasId

`func (o *StatementItemsInner) HasId() bool`

HasId returns a boolean if a field has been set.

### GetTime

`func (o *StatementItemsInner) GetTime() float32`

GetTime returns the Time field if non-nil, zero value otherwise.

### GetTimeOk

`func (o *StatementItemsInner) GetTimeOk() (*float32, bool)`

GetTimeOk returns a tuple with the Time field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetTime

`func (o *StatementItemsInner) SetTime(v float32)`

SetTime sets Time field to given value.

### HasTime

`func (o *StatementItemsInner) HasTime() bool`

HasTime returns a boolean if a field has been set.

### GetDescription

`func (o *StatementItemsInner) GetDescription() string`

GetDescription returns the Description field if non-nil, zero value otherwise.

### GetDescriptionOk

`func (o *StatementItemsInner) GetDescriptionOk() (*string, bool)`

GetDescriptionOk returns a tuple with the Description field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetDescription

`func (o *StatementItemsInner) SetDescription(v string)`

SetDescription sets Description field to given value.

### HasDescription

`func (o *StatementItemsInner) HasDescription() bool`

HasDescription returns a boolean if a field has been set.

### GetMcc

`func (o *StatementItemsInner) GetMcc() float32`

GetMcc returns the Mcc field if non-nil, zero value otherwise.

### GetMccOk

`func (o *StatementItemsInner) GetMccOk() (*float32, bool)`

GetMccOk returns a tuple with the Mcc field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetMcc

`func (o *StatementItemsInner) SetMcc(v float32)`

SetMcc sets Mcc field to given value.

### HasMcc

`func (o *StatementItemsInner) HasMcc() bool`

HasMcc returns a boolean if a field has been set.

### GetOriginalMcc

`func (o *StatementItemsInner) GetOriginalMcc() float32`

GetOriginalMcc returns the OriginalMcc field if non-nil, zero value otherwise.

### GetOriginalMccOk

`func (o *StatementItemsInner) GetOriginalMccOk() (*float32, bool)`

GetOriginalMccOk returns a tuple with the OriginalMcc field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetOriginalMcc

`func (o *StatementItemsInner) SetOriginalMcc(v float32)`

SetOriginalMcc sets OriginalMcc field to given value.

### HasOriginalMcc

`func (o *StatementItemsInner) HasOriginalMcc() bool`

HasOriginalMcc returns a boolean if a field has been set.

### GetHold

`func (o *StatementItemsInner) GetHold() bool`

GetHold returns the Hold field if non-nil, zero value otherwise.

### GetHoldOk

`func (o *StatementItemsInner) GetHoldOk() (*bool, bool)`

GetHoldOk returns a tuple with the Hold field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetHold

`func (o *StatementItemsInner) SetHold(v bool)`

SetHold sets Hold field to given value.

### HasHold

`func (o *StatementItemsInner) HasHold() bool`

HasHold returns a boolean if a field has been set.

### GetAmount

`func (o *StatementItemsInner) GetAmount() float32`

GetAmount returns the Amount field if non-nil, zero value otherwise.

### GetAmountOk

`func (o *StatementItemsInner) GetAmountOk() (*float32, bool)`

GetAmountOk returns a tuple with the Amount field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetAmount

`func (o *StatementItemsInner) SetAmount(v float32)`

SetAmount sets Amount field to given value.

### HasAmount

`func (o *StatementItemsInner) HasAmount() bool`

HasAmount returns a boolean if a field has been set.

### GetOperationAmount

`func (o *StatementItemsInner) GetOperationAmount() float32`

GetOperationAmount returns the OperationAmount field if non-nil, zero value otherwise.

### GetOperationAmountOk

`func (o *StatementItemsInner) GetOperationAmountOk() (*float32, bool)`

GetOperationAmountOk returns a tuple with the OperationAmount field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetOperationAmount

`func (o *StatementItemsInner) SetOperationAmount(v float32)`

SetOperationAmount sets OperationAmount field to given value.

### HasOperationAmount

`func (o *StatementItemsInner) HasOperationAmount() bool`

HasOperationAmount returns a boolean if a field has been set.

### GetCurrencyCode

`func (o *StatementItemsInner) GetCurrencyCode() float32`

GetCurrencyCode returns the CurrencyCode field if non-nil, zero value otherwise.

### GetCurrencyCodeOk

`func (o *StatementItemsInner) GetCurrencyCodeOk() (*float32, bool)`

GetCurrencyCodeOk returns a tuple with the CurrencyCode field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetCurrencyCode

`func (o *StatementItemsInner) SetCurrencyCode(v float32)`

SetCurrencyCode sets CurrencyCode field to given value.

### HasCurrencyCode

`func (o *StatementItemsInner) HasCurrencyCode() bool`

HasCurrencyCode returns a boolean if a field has been set.

### GetCommissionRate

`func (o *StatementItemsInner) GetCommissionRate() float32`

GetCommissionRate returns the CommissionRate field if non-nil, zero value otherwise.

### GetCommissionRateOk

`func (o *StatementItemsInner) GetCommissionRateOk() (*float32, bool)`

GetCommissionRateOk returns a tuple with the CommissionRate field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetCommissionRate

`func (o *StatementItemsInner) SetCommissionRate(v float32)`

SetCommissionRate sets CommissionRate field to given value.

### HasCommissionRate

`func (o *StatementItemsInner) HasCommissionRate() bool`

HasCommissionRate returns a boolean if a field has been set.

### GetCashbackAmount

`func (o *StatementItemsInner) GetCashbackAmount() float32`

GetCashbackAmount returns the CashbackAmount field if non-nil, zero value otherwise.

### GetCashbackAmountOk

`func (o *StatementItemsInner) GetCashbackAmountOk() (*float32, bool)`

GetCashbackAmountOk returns a tuple with the CashbackAmount field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetCashbackAmount

`func (o *StatementItemsInner) SetCashbackAmount(v float32)`

SetCashbackAmount sets CashbackAmount field to given value.

### HasCashbackAmount

`func (o *StatementItemsInner) HasCashbackAmount() bool`

HasCashbackAmount returns a boolean if a field has been set.

### GetBalance

`func (o *StatementItemsInner) GetBalance() float32`

GetBalance returns the Balance field if non-nil, zero value otherwise.

### GetBalanceOk

`func (o *StatementItemsInner) GetBalanceOk() (*float32, bool)`

GetBalanceOk returns a tuple with the Balance field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetBalance

`func (o *StatementItemsInner) SetBalance(v float32)`

SetBalance sets Balance field to given value.

### HasBalance

`func (o *StatementItemsInner) HasBalance() bool`

HasBalance returns a boolean if a field has been set.

### GetComment

`func (o *StatementItemsInner) GetComment() string`

GetComment returns the Comment field if non-nil, zero value otherwise.

### GetCommentOk

`func (o *StatementItemsInner) GetCommentOk() (*string, bool)`

GetCommentOk returns a tuple with the Comment field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetComment

`func (o *StatementItemsInner) SetComment(v string)`

SetComment sets Comment field to given value.

### HasComment

`func (o *StatementItemsInner) HasComment() bool`

HasComment returns a boolean if a field has been set.

### GetReceiptId

`func (o *StatementItemsInner) GetReceiptId() string`

GetReceiptId returns the ReceiptId field if non-nil, zero value otherwise.

### GetReceiptIdOk

`func (o *StatementItemsInner) GetReceiptIdOk() (*string, bool)`

GetReceiptIdOk returns a tuple with the ReceiptId field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetReceiptId

`func (o *StatementItemsInner) SetReceiptId(v string)`

SetReceiptId sets ReceiptId field to given value.

### HasReceiptId

`func (o *StatementItemsInner) HasReceiptId() bool`

HasReceiptId returns a boolean if a field has been set.

### GetInvoiceId

`func (o *StatementItemsInner) GetInvoiceId() string`

GetInvoiceId returns the InvoiceId field if non-nil, zero value otherwise.

### GetInvoiceIdOk

`func (o *StatementItemsInner) GetInvoiceIdOk() (*string, bool)`

GetInvoiceIdOk returns a tuple with the InvoiceId field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetInvoiceId

`func (o *StatementItemsInner) SetInvoiceId(v string)`

SetInvoiceId sets InvoiceId field to given value.

### HasInvoiceId

`func (o *StatementItemsInner) HasInvoiceId() bool`

HasInvoiceId returns a boolean if a field has been set.

### GetCounterEdrpou

`func (o *StatementItemsInner) GetCounterEdrpou() string`

GetCounterEdrpou returns the CounterEdrpou field if non-nil, zero value otherwise.

### GetCounterEdrpouOk

`func (o *StatementItemsInner) GetCounterEdrpouOk() (*string, bool)`

GetCounterEdrpouOk returns a tuple with the CounterEdrpou field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetCounterEdrpou

`func (o *StatementItemsInner) SetCounterEdrpou(v string)`

SetCounterEdrpou sets CounterEdrpou field to given value.

### HasCounterEdrpou

`func (o *StatementItemsInner) HasCounterEdrpou() bool`

HasCounterEdrpou returns a boolean if a field has been set.

### GetCounterIban

`func (o *StatementItemsInner) GetCounterIban() string`

GetCounterIban returns the CounterIban field if non-nil, zero value otherwise.

### GetCounterIbanOk

`func (o *StatementItemsInner) GetCounterIbanOk() (*string, bool)`

GetCounterIbanOk returns a tuple with the CounterIban field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetCounterIban

`func (o *StatementItemsInner) SetCounterIban(v string)`

SetCounterIban sets CounterIban field to given value.

### HasCounterIban

`func (o *StatementItemsInner) HasCounterIban() bool`

HasCounterIban returns a boolean if a field has been set.

### GetCounterName

`func (o *StatementItemsInner) GetCounterName() string`

GetCounterName returns the CounterName field if non-nil, zero value otherwise.

### GetCounterNameOk

`func (o *StatementItemsInner) GetCounterNameOk() (*string, bool)`

GetCounterNameOk returns a tuple with the CounterName field if it's non-nil, zero value otherwise
and a boolean to check if the value has been set.

### SetCounterName

`func (o *StatementItemsInner) SetCounterName(v string)`

SetCounterName sets CounterName field to given value.

### HasCounterName

`func (o *StatementItemsInner) HasCounterName() bool`

HasCounterName returns a boolean if a field has been set.


[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


