/*
Monobank open API

API для отримання інформації про виписки та стан особистого рахунку та рахунків ФОП. Для надання доступу потрібно пройти авторизацію у особистому кабінеті https://api.monobank.ua/ та отримати токен для персонального використання.  Якщо у вас є запитання щодо роботи API, запрошуємо до ком'юніті у [Telegram-групі](https://t.me/joinchat/FiAEWhDf-QzTqM4wzEtffw). API недоступне для клієнтів до 16 років, дані за дитячими рахунками доступні з батьківського акаунту. Якщо у вас є сервіс і ви хочете централізовано приєднатися до API для надання послуг клієнтам, потрібно підключитися до [API для провайдерів послуг](/docs/corporate.html), що має більше можливостей. Якщо дані клієнтів не будуть надходити на ваші сервери або ви робите сервіс для своєї родини, використання корпоративного API необов'язкове. Розробка бібліотек або програм, які будуть використовувати клієнти особисто (дані клієнта не будуть проходити черeз вузли розробника), також не потребують використання корпоративного API.  Це надасть змогу клієнтам monobank авторизуватись у вашому сервісі (наприклад, у фінансовому менеджері) для надання інформації про стан рахунку або виписки.  У разі виявлення експлуатації цього API в якості корпоративного, банк залишає за собою право накласти санкції на компанію.

API version: v2303
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package monobank

import (
	"encoding/json"
)

// checks if the SetWebHook type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SetWebHook{}

// SetWebHook URL для надсиляння подій по зміні балансу рахунків фізичних осіб, ФОП та банок
type SetWebHook struct {
	WebHookUrl *string `json:"webHookUrl,omitempty"`
}

// NewSetWebHook instantiates a new SetWebHook object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSetWebHook() *SetWebHook {
	this := SetWebHook{}
	return &this
}

// NewSetWebHookWithDefaults instantiates a new SetWebHook object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSetWebHookWithDefaults() *SetWebHook {
	this := SetWebHook{}
	return &this
}

// GetWebHookUrl returns the WebHookUrl field value if set, zero value otherwise.
func (o *SetWebHook) GetWebHookUrl() string {
	if o == nil || IsNil(o.WebHookUrl) {
		var ret string
		return ret
	}
	return *o.WebHookUrl
}

// GetWebHookUrlOk returns a tuple with the WebHookUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SetWebHook) GetWebHookUrlOk() (*string, bool) {
	if o == nil || IsNil(o.WebHookUrl) {
		return nil, false
	}
	return o.WebHookUrl, true
}

// HasWebHookUrl returns a boolean if a field has been set.
func (o *SetWebHook) HasWebHookUrl() bool {
	if o != nil && !IsNil(o.WebHookUrl) {
		return true
	}

	return false
}

// SetWebHookUrl gets a reference to the given string and assigns it to the WebHookUrl field.
func (o *SetWebHook) SetWebHookUrl(v string) {
	o.WebHookUrl = &v
}

func (o SetWebHook) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SetWebHook) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.WebHookUrl) {
		toSerialize["webHookUrl"] = o.WebHookUrl
	}
	return toSerialize, nil
}

type NullableSetWebHook struct {
	value *SetWebHook
	isSet bool
}

func (v NullableSetWebHook) Get() *SetWebHook {
	return v.value
}

func (v *NullableSetWebHook) Set(val *SetWebHook) {
	v.value = val
	v.isSet = true
}

func (v NullableSetWebHook) IsSet() bool {
	return v.isSet
}

func (v *NullableSetWebHook) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSetWebHook(val *SetWebHook) *NullableSetWebHook {
	return &NullableSetWebHook{value: val, isSet: true}
}

func (v NullableSetWebHook) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSetWebHook) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


