/*
Monobank open API

API для отримання інформації про виписки та стан особистого рахунку та рахунків ФОП. Для надання доступу потрібно пройти авторизацію у особистому кабінеті https://api.monobank.ua/ та отримати токен для персонального використання.  Якщо у вас є запитання щодо роботи API, запрошуємо до ком'юніті у [Telegram-групі](https://t.me/joinchat/FiAEWhDf-QzTqM4wzEtffw). API недоступне для клієнтів до 16 років, дані за дитячими рахунками доступні з батьківського акаунту. Якщо у вас є сервіс і ви хочете централізовано приєднатися до API для надання послуг клієнтам, потрібно підключитися до [API для провайдерів послуг](/docs/corporate.html), що має більше можливостей. Якщо дані клієнтів не будуть надходити на ваші сервери або ви робите сервіс для своєї родини, використання корпоративного API необов'язкове. Розробка бібліотек або програм, які будуть використовувати клієнти особисто (дані клієнта не будуть проходити черeз вузли розробника), також не потребують використання корпоративного API.  Це надасть змогу клієнтам monobank авторизуватись у вашому сервісі (наприклад, у фінансовому менеджері) для надання інформації про стан рахунку або виписки.  У разі виявлення експлуатації цього API в якості корпоративного, банк залишає за собою право накласти санкції на компанію.

API version: v2303
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package monobank

import (
	"encoding/json"
)

// checks if the UserInfoAccountsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UserInfoAccountsInner{}

// UserInfoAccountsInner struct for UserInfoAccountsInner
type UserInfoAccountsInner struct {
	// Ідентифікатор рахунку
	Id *string `json:"id,omitempty"`
	// Ідентифікатор для сервісу https://send.monobank.ua/{sendId}
	SendId *string `json:"sendId,omitempty"`
	// Баланс рахунку в мінімальних одиницях валюти (копійках, центах)
	Balance *float32 `json:"balance,omitempty"`
	// Кредитний ліміт
	CreditLimit *float32 `json:"creditLimit,omitempty"`
	// Тип рахунку
	Type *string `json:"type,omitempty"`
	// Код валюти рахунку відповідно ISO 4217
	CurrencyCode *float32 `json:"currencyCode,omitempty"`
	// Тип кешбеку який нараховується на рахунок
	CashbackType *string `json:"cashbackType,omitempty"`
	// Перелік замаскованних номерів карт (більше одного може бути у преміальних карт)
	MaskedPan *Array `json:"maskedPan,omitempty"`
	// IBAN рахунку
	Iban *string `json:"iban,omitempty"`
}

// NewUserInfoAccountsInner instantiates a new UserInfoAccountsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUserInfoAccountsInner() *UserInfoAccountsInner {
	this := UserInfoAccountsInner{}
	return &this
}

// NewUserInfoAccountsInnerWithDefaults instantiates a new UserInfoAccountsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserInfoAccountsInnerWithDefaults() *UserInfoAccountsInner {
	this := UserInfoAccountsInner{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *UserInfoAccountsInner) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoAccountsInner) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *UserInfoAccountsInner) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *UserInfoAccountsInner) SetId(v string) {
	o.Id = &v
}

// GetSendId returns the SendId field value if set, zero value otherwise.
func (o *UserInfoAccountsInner) GetSendId() string {
	if o == nil || IsNil(o.SendId) {
		var ret string
		return ret
	}
	return *o.SendId
}

// GetSendIdOk returns a tuple with the SendId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoAccountsInner) GetSendIdOk() (*string, bool) {
	if o == nil || IsNil(o.SendId) {
		return nil, false
	}
	return o.SendId, true
}

// HasSendId returns a boolean if a field has been set.
func (o *UserInfoAccountsInner) HasSendId() bool {
	if o != nil && !IsNil(o.SendId) {
		return true
	}

	return false
}

// SetSendId gets a reference to the given string and assigns it to the SendId field.
func (o *UserInfoAccountsInner) SetSendId(v string) {
	o.SendId = &v
}

// GetBalance returns the Balance field value if set, zero value otherwise.
func (o *UserInfoAccountsInner) GetBalance() float32 {
	if o == nil || IsNil(o.Balance) {
		var ret float32
		return ret
	}
	return *o.Balance
}

// GetBalanceOk returns a tuple with the Balance field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoAccountsInner) GetBalanceOk() (*float32, bool) {
	if o == nil || IsNil(o.Balance) {
		return nil, false
	}
	return o.Balance, true
}

// HasBalance returns a boolean if a field has been set.
func (o *UserInfoAccountsInner) HasBalance() bool {
	if o != nil && !IsNil(o.Balance) {
		return true
	}

	return false
}

// SetBalance gets a reference to the given float32 and assigns it to the Balance field.
func (o *UserInfoAccountsInner) SetBalance(v float32) {
	o.Balance = &v
}

// GetCreditLimit returns the CreditLimit field value if set, zero value otherwise.
func (o *UserInfoAccountsInner) GetCreditLimit() float32 {
	if o == nil || IsNil(o.CreditLimit) {
		var ret float32
		return ret
	}
	return *o.CreditLimit
}

// GetCreditLimitOk returns a tuple with the CreditLimit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoAccountsInner) GetCreditLimitOk() (*float32, bool) {
	if o == nil || IsNil(o.CreditLimit) {
		return nil, false
	}
	return o.CreditLimit, true
}

// HasCreditLimit returns a boolean if a field has been set.
func (o *UserInfoAccountsInner) HasCreditLimit() bool {
	if o != nil && !IsNil(o.CreditLimit) {
		return true
	}

	return false
}

// SetCreditLimit gets a reference to the given float32 and assigns it to the CreditLimit field.
func (o *UserInfoAccountsInner) SetCreditLimit(v float32) {
	o.CreditLimit = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *UserInfoAccountsInner) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoAccountsInner) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *UserInfoAccountsInner) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *UserInfoAccountsInner) SetType(v string) {
	o.Type = &v
}

// GetCurrencyCode returns the CurrencyCode field value if set, zero value otherwise.
func (o *UserInfoAccountsInner) GetCurrencyCode() float32 {
	if o == nil || IsNil(o.CurrencyCode) {
		var ret float32
		return ret
	}
	return *o.CurrencyCode
}

// GetCurrencyCodeOk returns a tuple with the CurrencyCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoAccountsInner) GetCurrencyCodeOk() (*float32, bool) {
	if o == nil || IsNil(o.CurrencyCode) {
		return nil, false
	}
	return o.CurrencyCode, true
}

// HasCurrencyCode returns a boolean if a field has been set.
func (o *UserInfoAccountsInner) HasCurrencyCode() bool {
	if o != nil && !IsNil(o.CurrencyCode) {
		return true
	}

	return false
}

// SetCurrencyCode gets a reference to the given float32 and assigns it to the CurrencyCode field.
func (o *UserInfoAccountsInner) SetCurrencyCode(v float32) {
	o.CurrencyCode = &v
}

// GetCashbackType returns the CashbackType field value if set, zero value otherwise.
func (o *UserInfoAccountsInner) GetCashbackType() string {
	if o == nil || IsNil(o.CashbackType) {
		var ret string
		return ret
	}
	return *o.CashbackType
}

// GetCashbackTypeOk returns a tuple with the CashbackType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoAccountsInner) GetCashbackTypeOk() (*string, bool) {
	if o == nil || IsNil(o.CashbackType) {
		return nil, false
	}
	return o.CashbackType, true
}

// HasCashbackType returns a boolean if a field has been set.
func (o *UserInfoAccountsInner) HasCashbackType() bool {
	if o != nil && !IsNil(o.CashbackType) {
		return true
	}

	return false
}

// SetCashbackType gets a reference to the given string and assigns it to the CashbackType field.
func (o *UserInfoAccountsInner) SetCashbackType(v string) {
	o.CashbackType = &v
}

// GetMaskedPan returns the MaskedPan field value if set, zero value otherwise.
func (o *UserInfoAccountsInner) GetMaskedPan() Array {
	if o == nil || IsNil(o.MaskedPan) {
		var ret Array
		return ret
	}
	return *o.MaskedPan
}

// GetMaskedPanOk returns a tuple with the MaskedPan field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoAccountsInner) GetMaskedPanOk() (*Array, bool) {
	if o == nil || IsNil(o.MaskedPan) {
		return nil, false
	}
	return o.MaskedPan, true
}

// HasMaskedPan returns a boolean if a field has been set.
func (o *UserInfoAccountsInner) HasMaskedPan() bool {
	if o != nil && !IsNil(o.MaskedPan) {
		return true
	}

	return false
}

// SetMaskedPan gets a reference to the given Array and assigns it to the MaskedPan field.
func (o *UserInfoAccountsInner) SetMaskedPan(v Array) {
	o.MaskedPan = &v
}

// GetIban returns the Iban field value if set, zero value otherwise.
func (o *UserInfoAccountsInner) GetIban() string {
	if o == nil || IsNil(o.Iban) {
		var ret string
		return ret
	}
	return *o.Iban
}

// GetIbanOk returns a tuple with the Iban field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoAccountsInner) GetIbanOk() (*string, bool) {
	if o == nil || IsNil(o.Iban) {
		return nil, false
	}
	return o.Iban, true
}

// HasIban returns a boolean if a field has been set.
func (o *UserInfoAccountsInner) HasIban() bool {
	if o != nil && !IsNil(o.Iban) {
		return true
	}

	return false
}

// SetIban gets a reference to the given string and assigns it to the Iban field.
func (o *UserInfoAccountsInner) SetIban(v string) {
	o.Iban = &v
}

func (o UserInfoAccountsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UserInfoAccountsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.SendId) {
		toSerialize["sendId"] = o.SendId
	}
	if !IsNil(o.Balance) {
		toSerialize["balance"] = o.Balance
	}
	if !IsNil(o.CreditLimit) {
		toSerialize["creditLimit"] = o.CreditLimit
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.CurrencyCode) {
		toSerialize["currencyCode"] = o.CurrencyCode
	}
	if !IsNil(o.CashbackType) {
		toSerialize["cashbackType"] = o.CashbackType
	}
	if !IsNil(o.MaskedPan) {
		toSerialize["maskedPan"] = o.MaskedPan
	}
	if !IsNil(o.Iban) {
		toSerialize["iban"] = o.Iban
	}
	return toSerialize, nil
}

type NullableUserInfoAccountsInner struct {
	value *UserInfoAccountsInner
	isSet bool
}

func (v NullableUserInfoAccountsInner) Get() *UserInfoAccountsInner {
	return v.value
}

func (v *NullableUserInfoAccountsInner) Set(val *UserInfoAccountsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableUserInfoAccountsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableUserInfoAccountsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserInfoAccountsInner(val *UserInfoAccountsInner) *NullableUserInfoAccountsInner {
	return &NullableUserInfoAccountsInner{value: val, isSet: true}
}

func (v NullableUserInfoAccountsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserInfoAccountsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


