/*
Monobank open API

API для отримання інформації про виписки та стан особистого рахунку та рахунків ФОП. Для надання доступу потрібно пройти авторизацію у особистому кабінеті https://api.monobank.ua/ та отримати токен для персонального використання.  Якщо у вас є запитання щодо роботи API, запрошуємо до ком'юніті у [Telegram-групі](https://t.me/joinchat/FiAEWhDf-QzTqM4wzEtffw). API недоступне для клієнтів до 16 років, дані за дитячими рахунками доступні з батьківського акаунту. Якщо у вас є сервіс і ви хочете централізовано приєднатися до API для надання послуг клієнтам, потрібно підключитися до [API для провайдерів послуг](/docs/corporate.html), що має більше можливостей. Якщо дані клієнтів не будуть надходити на ваші сервери або ви робите сервіс для своєї родини, використання корпоративного API необов'язкове. Розробка бібліотек або програм, які будуть використовувати клієнти особисто (дані клієнта не будуть проходити черeз вузли розробника), також не потребують використання корпоративного API.  Це надасть змогу клієнтам monobank авторизуватись у вашому сервісі (наприклад, у фінансовому менеджері) для надання інформації про стан рахунку або виписки.  У разі виявлення експлуатації цього API в якості корпоративного, банк залишає за собою право накласти санкції на компанію.

API version: v2303
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package monobank

import (
	"encoding/json"
)

// checks if the UserInfoJarsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UserInfoJarsInner{}

// UserInfoJarsInner struct for UserInfoJarsInner
type UserInfoJarsInner struct {
	// Ідентифікатор банки
	Id *string `json:"id,omitempty"`
	// Ідентифікатор для сервісу https://send.monobank.ua/{sendId}
	SendId *string `json:"sendId,omitempty"`
	// Назва банки
	Title *string `json:"title,omitempty"`
	// Опис банки
	Description *string `json:"description,omitempty"`
	// Код валюти банки відповідно ISO 4217
	CurrencyCode *float32 `json:"currencyCode,omitempty"`
	// Баланс банки в мінімальних одиницях валюти (копійках, центах)
	Balance *float32 `json:"balance,omitempty"`
	// Цільова сума для накопичення в банці в мінімальних одиницях валюти (копійках, центах)
	Goal *float32 `json:"goal,omitempty"`
}

// NewUserInfoJarsInner instantiates a new UserInfoJarsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUserInfoJarsInner() *UserInfoJarsInner {
	this := UserInfoJarsInner{}
	return &this
}

// NewUserInfoJarsInnerWithDefaults instantiates a new UserInfoJarsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserInfoJarsInnerWithDefaults() *UserInfoJarsInner {
	this := UserInfoJarsInner{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *UserInfoJarsInner) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoJarsInner) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *UserInfoJarsInner) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *UserInfoJarsInner) SetId(v string) {
	o.Id = &v
}

// GetSendId returns the SendId field value if set, zero value otherwise.
func (o *UserInfoJarsInner) GetSendId() string {
	if o == nil || IsNil(o.SendId) {
		var ret string
		return ret
	}
	return *o.SendId
}

// GetSendIdOk returns a tuple with the SendId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoJarsInner) GetSendIdOk() (*string, bool) {
	if o == nil || IsNil(o.SendId) {
		return nil, false
	}
	return o.SendId, true
}

// HasSendId returns a boolean if a field has been set.
func (o *UserInfoJarsInner) HasSendId() bool {
	if o != nil && !IsNil(o.SendId) {
		return true
	}

	return false
}

// SetSendId gets a reference to the given string and assigns it to the SendId field.
func (o *UserInfoJarsInner) SetSendId(v string) {
	o.SendId = &v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *UserInfoJarsInner) GetTitle() string {
	if o == nil || IsNil(o.Title) {
		var ret string
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoJarsInner) GetTitleOk() (*string, bool) {
	if o == nil || IsNil(o.Title) {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *UserInfoJarsInner) HasTitle() bool {
	if o != nil && !IsNil(o.Title) {
		return true
	}

	return false
}

// SetTitle gets a reference to the given string and assigns it to the Title field.
func (o *UserInfoJarsInner) SetTitle(v string) {
	o.Title = &v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *UserInfoJarsInner) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoJarsInner) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *UserInfoJarsInner) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *UserInfoJarsInner) SetDescription(v string) {
	o.Description = &v
}

// GetCurrencyCode returns the CurrencyCode field value if set, zero value otherwise.
func (o *UserInfoJarsInner) GetCurrencyCode() float32 {
	if o == nil || IsNil(o.CurrencyCode) {
		var ret float32
		return ret
	}
	return *o.CurrencyCode
}

// GetCurrencyCodeOk returns a tuple with the CurrencyCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoJarsInner) GetCurrencyCodeOk() (*float32, bool) {
	if o == nil || IsNil(o.CurrencyCode) {
		return nil, false
	}
	return o.CurrencyCode, true
}

// HasCurrencyCode returns a boolean if a field has been set.
func (o *UserInfoJarsInner) HasCurrencyCode() bool {
	if o != nil && !IsNil(o.CurrencyCode) {
		return true
	}

	return false
}

// SetCurrencyCode gets a reference to the given float32 and assigns it to the CurrencyCode field.
func (o *UserInfoJarsInner) SetCurrencyCode(v float32) {
	o.CurrencyCode = &v
}

// GetBalance returns the Balance field value if set, zero value otherwise.
func (o *UserInfoJarsInner) GetBalance() float32 {
	if o == nil || IsNil(o.Balance) {
		var ret float32
		return ret
	}
	return *o.Balance
}

// GetBalanceOk returns a tuple with the Balance field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoJarsInner) GetBalanceOk() (*float32, bool) {
	if o == nil || IsNil(o.Balance) {
		return nil, false
	}
	return o.Balance, true
}

// HasBalance returns a boolean if a field has been set.
func (o *UserInfoJarsInner) HasBalance() bool {
	if o != nil && !IsNil(o.Balance) {
		return true
	}

	return false
}

// SetBalance gets a reference to the given float32 and assigns it to the Balance field.
func (o *UserInfoJarsInner) SetBalance(v float32) {
	o.Balance = &v
}

// GetGoal returns the Goal field value if set, zero value otherwise.
func (o *UserInfoJarsInner) GetGoal() float32 {
	if o == nil || IsNil(o.Goal) {
		var ret float32
		return ret
	}
	return *o.Goal
}

// GetGoalOk returns a tuple with the Goal field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserInfoJarsInner) GetGoalOk() (*float32, bool) {
	if o == nil || IsNil(o.Goal) {
		return nil, false
	}
	return o.Goal, true
}

// HasGoal returns a boolean if a field has been set.
func (o *UserInfoJarsInner) HasGoal() bool {
	if o != nil && !IsNil(o.Goal) {
		return true
	}

	return false
}

// SetGoal gets a reference to the given float32 and assigns it to the Goal field.
func (o *UserInfoJarsInner) SetGoal(v float32) {
	o.Goal = &v
}

func (o UserInfoJarsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UserInfoJarsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.SendId) {
		toSerialize["sendId"] = o.SendId
	}
	if !IsNil(o.Title) {
		toSerialize["title"] = o.Title
	}
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	if !IsNil(o.CurrencyCode) {
		toSerialize["currencyCode"] = o.CurrencyCode
	}
	if !IsNil(o.Balance) {
		toSerialize["balance"] = o.Balance
	}
	if !IsNil(o.Goal) {
		toSerialize["goal"] = o.Goal
	}
	return toSerialize, nil
}

type NullableUserInfoJarsInner struct {
	value *UserInfoJarsInner
	isSet bool
}

func (v NullableUserInfoJarsInner) Get() *UserInfoJarsInner {
	return v.value
}

func (v *NullableUserInfoJarsInner) Set(val *UserInfoJarsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableUserInfoJarsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableUserInfoJarsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserInfoJarsInner(val *UserInfoJarsInner) *NullableUserInfoJarsInner {
	return &NullableUserInfoJarsInner{value: val, isSet: true}
}

func (v NullableUserInfoJarsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserInfoJarsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


